



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>LightOJ 1229 Treblecross（SG函数打表 + 遍历）题解</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">LightOJ 1229 Treblecross（SG函数打表 + 遍历）题解</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 22:55:39 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题意：给你一串含&ldquo;.&rdquo;和&ldquo;X&rdquo;的字串，每次一个玩家可以把&lsquo;."变成&ldquo;X&rdquo;，谁先弄到三个XXX就赢。假如先手必赢，输出所有能必赢的第一步，否则输出0。</p>
<p>思路：显然如果一个X周围两格有X那么肯定能一步变成XXX，所以两个人都要避免在自己回合产生这种情况。如果一开始就存在上述情况，那么肯定是那一步。否则我遍历每一个空格看看能不能下这一步。满足我在这个空格变成&ldquo;X&rdquo;不会造成上述情况，然后算出nim和是否留给对手一个必败态。</p>
<p>设sg[x]表示长度为x的空格的sg函数，然后我遍历1~x位置变成&ldquo;X&rdquo;,那么空格键会被我分成两块（比如.....我在3位置下X，那么空格被我分成了左0右0两块，注意X旁边两块不能动）。</p>
<p>代码：</p>
<div>
<pre class="prettyprint linenums">#include&lt;set&gt;<br />
#include&lt;map&gt;<br />
#include&lt;stack&gt;<br />
#include&lt;cmath&gt;<br />
#include&lt;queue&gt;<br />
#include&lt;vector&gt;<br />
#include&lt;cstdio&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;iostream&gt;<br />
#include&lt;algorithm&gt;<br />
typedef long long ll;<br />
const int maxn =  + ;<br />
const int seed = ;<br />
const ll MOD = 1e9 + ;<br />
const int INF = 0x3f3f3f3f;<br />
using namespace std;<br />
int sg[maxn], s[maxn], ans[maxn], pos;<br />
char str[maxn];<br />
void getSG(){<br />
    sg[] = ;<br />
    for(int i = ; i &lt; maxn; i++){<br />
        memset(s, , sizeof(s));<br />
        for(int j = ; j &lt;= i; j++){<br />
            int t = ;<br />
            if(i - j -  &gt;= ) t ^= sg[i - j - ];<br />
            if(j -  &gt;= ) t ^= sg[j - ];<br />
            s[t] = ;<br />
        }<br />
        for(int j = ; j &lt; maxn; j++){<br />
            if(!s[j]){<br />
                sg[i] = j;<br />
                break;<br />
            }<br />
        }<br />
    }<br />
}<br />
bool check(){<br />
    ll ret = ;<br />
    int num = , len = strlen(str);<br />
    for(int i = ; i &lt; len; i++){<br />
        if(str[i] == 'X'){<br />
            if((i &gt;=  &amp;&amp; str[i - ] == 'X') || (i &gt;=  &amp;&amp; str[i - ] == 'X') || (i +  &lt; len &amp;&amp; str[i + ] == 'X') || (i +  &lt; len &amp;&amp; str[i + ] == 'X')){<br />
                return false;<br />
            }<br />
            if(str[i - num - ] == 'X' &amp;&amp; i - num -  &gt;= )<br />
                num -= ;<br />
            num -= ;<br />
            if(num &gt;= ) ret ^= sg[num];<br />
            num = ;<br />
        }<br />
        else{<br />
            num++;<br />
        }<br />
    }<br />
    if(str[len -  - num] == 'X' &amp;&amp; len -  - num &gt;= )<br />
            num -= ;<br />
    if(num &gt;= ) ret ^= sg[num];<br />
    return ret == ;<br />
}<br />
void solve(){<br />
    pos = ;<br />
    int len = strlen(str);<br />
    for(int i = ; i &lt; len; i++){<br />
        if(str[i] == '.'){<br />
            str[i] = 'X';<br />
            if(i +  &lt; len &amp;&amp; i -  &gt;=  &amp;&amp; str[i + ] == 'X' &amp;&amp; str[i - ] == 'X'){<br />
                ans[pos++] = i + ;<br />
            }<br />
            else if(i +  &lt; len &amp;&amp; i +  &lt; len &amp;&amp; str[i + ] == 'X' &amp;&amp; str[i + ] == 'X'){<br />
                ans[pos++] = i + ;<br />
            }<br />
            else if(i -  &gt;=  &amp;&amp; i -  &gt;=  &amp;&amp; str[i - ] == 'X' &amp;&amp; str[i - ] == 'X'){<br />
                ans[pos++] = i + ;<br />
            }<br />
            else if(check()){<br />
                ans[pos++] = i + ;<br />
            }<br />
            str[i] = '.';<br />
        }<br />
    }<br />
}<br />
int main(){<br />
    int T, Case = ;<br />
    getSG();<br />
    scanf("%d", &amp;T);<br />
    while(T--){<br />
        scanf("%s", str);<br />
        solve();<br />
        printf("Case %d:", Case++);<br />
        if(pos == ) printf(" 0\n");<br />
        else{<br />
            for(int i = ; i &lt; pos; i++){<br />
                printf(" %d", ans[i]);<br />
            }<br />
            printf("\n");<br />
        }<br />
    }<br />
    return ;<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4yogjq.html">多视图学习利器----CCA（典型相关分析）及MATLAB实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyo1dx8.html">Android 中BaseActivty</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq42ywe9.html">Oracle nvl&lpar;&rpar;&comma;nvl2&lpar;&rpar;函数介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8z50218.html">Nuget程序包 使用log4net</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnnjn6q.html">2013年5月~2013年11月份（转接关于ns51服务平台项目）相关资料：</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e112pz9.html">echarts饼图--数据交互</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vd55n8.html">spring mvc 中文乱码 post与get的方法解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvj701q.html">函数 sort，unique，stable&lowbar;sort，count&lowbar;if，谓词</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdmv2e8.html">careercup-排序和查找 11&period;3</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j03ro4q.html">&lbrack;&period;NET&rsqb;Repeater控件使用技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yl115q.html">Axure 原型设计工具画业务流程图</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1nnxyq.html">python&lowbar;如何通过twisted实现数据库异步插入？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jo5wl8.html">scala时间和时间戳互转</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1zo5w9.html">Windows PowerShell基本语法及常用命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll7yl0q.html">Android 屏幕操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll2lkxq.html">MUI  自定义从底部弹出的弹出框</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zypvrd9.html">Springboot 2&period;0&period;x 集成基于Centos7的Redis集群安装及配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j13mx49.html">从今天开始 每天记录HTML，CSS 部分的学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m20k10q.html">live555 学习资料</a>
		</li>
						<li><a href="https://www.batexi.com/a/93px74g8.html">20155306  2016-2017-2 《Java程序设计》第5周学习总结</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2kxrkxq.html">AspNetPager&period;dll 分页控件使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4p4xnnq.html">Java List &amp;lt&semi;T&amp;gt&semi; T&lbrack;&rsqb; toArray&lpar;T&lbrack;&rsqb; a&rpar; implementation</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdj563xq.html">什么是 Delta 文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppkn149.html">&lbrack;py&rsqb;列表生成式-支持条件&comma;多值的拼接</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvez1v19.html">Java序列化总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/902jrm4q.html">接口测试xml格式转换成json</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdjdj6vq.html">Spring Security中异常上抛机制及对于转型处理的一些感悟</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vp5k2q.html">VCS中的覆盖率分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwl5o639.html">cf428c  模拟题</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1vppy0q.html">Solr安装中文分词器IK</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
